# References and related links

EvoLP is heavily inspired by other packages and scientific works.

## Related Packages

### Julia

- [Metaheuristics](https://github.com/jmejia8/Metaheuristics.jl) is a package with metaheuristic solvers of all kinds.
- [Evolutionary](https://github.com/wildart/Evolutionary.jl) contains multiple GAs and EAs implementations.
- [GeneticAlgorithms](https://github.com/WestleyArgentum/GeneticAlgorithms.jl) is a somewhat outdated package for writing GAs.
- [BlackBoxOptim](https://github.com/robertfeldt/BlackBoxOptim.jl) is another blackbox optimisation package.
- [JuMP](https://github.com/jump-dev/JuMP.jl) is focused on mathematical optimisation for differentiable objective functions.

### Python

- [DEAP](https://github.com/DEAP/deap) is a somewhat outdated evolutionary playground for Python 2.
- [Pygmo](https://github.com/esa/pygmo2) is a fully-fledged optimisation suite from the European Space Agency.

## References

- [1] Eiben, A.E. and Smith, J.E. 2015. Introduction to Evolutionary Computing. Springer.
- [2] Kochenderfer, M.J. and Wheeler, T.A. 2019. Algorithms for optimization. Mit Press.
- [3] Simon, D. 2013. Evolutionary Optimization Algorithms. John Wiley & Sons.
- [4] Surjanovic, S. & Bingham, D. (2013). [Virtual Library of Simulation Experiments: Test Functions and Datasets](http://www.sfu.ca/~ssurjano).
